<%
	'************************************************************************************
	'*																					*
	'*																					*
	'*																					*
	'************************************************************************************
	Function CART_CalculateTax()
	
		ReDim aTaxStateInfo(2, 200)
		ReDim aTaxCountryInfo(2, 200)
		
		sCartTax	= 0
		iCount		= 0

		If ( bHasAccount ) Then
			sSQLText = "SELECT BillingStateCode, BillingCountryCode, BillingZip, shippingStateCode, shippingCountryCode, shippingZip FROM CustAltBill CAB, CustAltShip CAS WHERE CAS.AccountUnq = CAB.AccountUnq AND CAB.AccountUnq = " & iLoginAccountUnq & " AND CAS.Position = 0"
			Call DB_getFromDatabase(sSQLText, rsStoreData, "") 
			If ( NOT rsStoreData.EOF ) Then
				sStateCode			= rsStoreData("BillingStateCode")
				sCountryCode		= rsStoreData("BillingCountryCode")
				sZip				= rsStoreData("BillingZip")
				if rsStoreData("shippingStateCode")<>"" then
					' use shipping for tax calculation
					sStateCode		= rsStoreData("shippingStateCode")
					sCountryCode	= rsStoreData("shippingCountryCode")
					sZip			= rsStoreData("shippingZip")
				End If
				
				' get State/Provencial Taxes
				sSQLText = "SELECT TaxName, Percentage FROM StateTax WHERE StateCode = '" & sStateCode & "'"
				Call DB_getFromDatabase(sSQLText, rsStoreData2, "")
				If ( NOT rsStoreData2.EOF ) Then
					While ( NOT rsStoreData2.EOF )
						sCartTax					= sCartTax + CDbl(Trim(rsStoreData2("Percentage")))
						aTaxStateInfo(0, iCount)	= Trim(rsStoreData2("TaxName"))
						aTaxStateInfo(1, iCount)	= Trim(rsStoreData2("Percentage"))
						iCount						= iCount + 1
						rsStoreData2.movenext
					Wend
				End If
				Call DB_closeRecordset(rsStoreData2)
				
				' get Country Taxes (do this seperate, and not within a UNION so that it's easy for us to seperate them in the display
				sSQLText = "SELECT TaxName, Percentage FROM CountryTax WHERE CountryCode = '" & sCountryCode & "'"
				Call DB_getFromDatabase(sSQLText, rsStoreData2, "")
				If ( NOT rsStoreData2.EOF ) Then
					iCount = 0
					While ( NOT rsStoreData2.EOF )
						sCartTax					= sCartTax + CDbl(Trim(rsStoreData2("Percentage")))
						aTaxCountryInfo(0, iCount)	= Trim(rsStoreData2("TaxName"))
						aTaxCountryInfo(1, iCount)	= Trim(rsStoreData2("Percentage"))
						iCount						= iCount + 1
						rsStoreData2.movenext
					Wend
				End If
				Call DB_closeRecordset(rsStoreData2)
			End If
			Call DB_closeRecordset(rsStoreData)
		End If

		CART_CalculateTax = sCartTax

	End Function
	'************************************************************************************
	
	
	'************************************************************************************
	'*																					*
	'*																					*
	'*																					*
	'************************************************************************************
	function CART_CountRows()
	
		dim sSQLText, rsStoreData
		
		set rsStoreData	= CreateObject("ADODB.Recordset")
		CART_CountRows	= 0

		If ( sIDCart <> "" ) Then
			' check if the product is inside the cart
			sSQLText = "SELECT COUNT(idCartRow) FROM CartProducts WHERE IDCart=" & sIDCart
			call DB_getFromDatabase(sSQLText, rsStoreData, "")  
			If ( NOT rsStoreData.EOF ) Then
				CART_CountRows = rsStoreData(0)
			End If
			DB_closeRecordset(rsStoreData)
		End If
		
		set rsStoreData	= Nothing
	
	End Function
	'************************************************************************************
	

	'************************************************************************************
	'*																					*
	'*																					*
	'*																					*
	'************************************************************************************
	function CART_CalcTotal()       
	
		Dim sOptionsTotal, rsStoreData, rsStoreData2

		Set rsStoreData		= CreateObject("ADODB.Recordset")
		Set rsStoreData2	= CreateObject("ADODB.Recordset")
		sOptionsTotal		= 0
		CART_CalcTotal		= 0

		If ( sIDCart <> "" ) Then
			' iterate through cart rows
			sSQLText = "SELECT idCartRow, idProduct, quantity, unitPrice, unitBtoBPrice FROM CartProducts WHERE IDCart=" & sIDCart
			call DB_getFromDatabase(sSQLText, rsStoreData, "")  
			While ( NOT rsStoreData.EOF )
				sUnitPrice		= Cdbl(rsStoreData("unitPrice"))
				sUnitBtoBPrice	= Cdbl(rsStoreData("unitBtoBPrice"))
				sQuantity		= rsStoreData("quantity")
				sIDCartRow		= rsStoreData("idCartRow")
				sIDProduct		= rsStoreData("idProduct")
				sOptionsTotal	= 0
				
				' get Optionals value for that row    
				sSQLText = "SELECT SUM(CartProductsOptions.priceToAdd) AS optionsTotal FROM options, CartProductsOptions WHERE options.idOption=CartProductsOptions.idOption AND CartProductsOptions.idCartRow="&sIDCartRow     
				call DB_getFromDatabase(sSQLText, rsStoreData2, "cartFunctions")  
				If ( NOT rsStoreData2.EOF ) Then
					If ( NOT IsNull(rsStoreData2("optionsTotal")) ) Then
						sOptionsTotal = Cdbl(rsStoreData2("optionsTotal"))
					End If
				End If                
				Call DB_closeRecordset(rsStoreData2)
				
				If ( ( ACCNT_InGroup(iLoginAccountUnq, C_GROUP_WHOLESALE) ) And ( sUnitBtoBPrice > 0 ) ) Then
					CART_CalcTotal = CDbl(CART_CalcTotal + sQuantity * (sUnitBtoBPrice + sOptionsTotal))
				Else
					CART_CalcTotal = CDbl(CART_CalcTotal + sQuantity * (sUnitPrice + sOptionsTotal))
				End If

				rsStoreData.movenext
			Wend
			Call DB_closeRecordset(rsStoreData)
		End If
		
		Set rsStoreData		= Nothing
		Set rsStoreData2	= Nothing
	
	End Function
	'************************************************************************************
	
	
	'************************************************************************************
	'*																					*
	'*	This returns the monitary amount of product that's been set as tax exempt		*
	'*		- subtract this from the subtotal when calculating tax						*
	'*																					*
	'************************************************************************************
	function CART_CalcTotalTaxExempt()       
	
		Dim sOptionsTotal, rsStoreData, rsStoreData2

		Set rsStoreData			= CreateObject("ADODB.Recordset")
		Set rsStoreData2		= CreateObject("ADODB.Recordset")
		sOptionsTotal			= 0
		CART_CalcTotalTaxExempt	= 0

		If ( sIDCart <> "" ) Then
			' iterate through cart rows
			sSQLText = "SELECT CP.idCartRow, CP.idProduct, CP.quantity, CP.unitPrice, CP.unitBtoBPrice FROM CartProducts CP, Products P WHERE P.idProduct = CP.idProduct AND P.TaxExempt = 'Y' AND CP.IDCart=" & sIDCart
			call DB_getFromDatabase(sSQLText, rsStoreData, "")  
			While ( NOT rsStoreData.EOF )
				sUnitPrice		= Cdbl(rsStoreData("unitPrice"))
				sUnitBtoBPrice	= Cdbl(rsStoreData("unitBtoBPrice"))
				sQuantity		= rsStoreData("quantity")
				sIDCartRow		= rsStoreData("idCartRow")
				sIDProduct		= rsStoreData("idProduct")
				sOptionsTotal	= 0
				
				' get Optionals value for that row
				sSQLText = "SELECT SUM(CartProductsOptions.priceToAdd) AS optionsTotal FROM options, CartProductsOptions WHERE options.idOption=CartProductsOptions.idOption AND CartProductsOptions.idCartRow="&sIDCartRow     
				call DB_getFromDatabase(sSQLText, rsStoreData2, "cartFunctions")  
				If ( NOT rsStoreData2.EOF ) Then
					If ( NOT IsNull(rsStoreData2("optionsTotal")) ) Then
						sOptionsTotal = Cdbl(rsStoreData2("optionsTotal"))
					End If
				End If                
				Call DB_closeRecordset(rsStoreData2)
				
				If ( ( ACCNT_InGroup(iLoginAccountUnq, C_GROUP_WHOLESALE) ) And ( sUnitBtoBPrice > 0 ) ) Then
					CART_CalcTotalTaxExempt = CDbl(CART_CalcTotalTaxExempt + sQuantity * (sUnitBtoBPrice + sOptionsTotal))
				Else
					CART_CalcTotalTaxExempt = CDbl(CART_CalcTotalTaxExempt + sQuantity * (sUnitPrice + sOptionsTotal))
				End If

				rsStoreData.movenext
			Wend
			Call DB_closeRecordset(rsStoreData)
		End If
		
		Set rsStoreData		= Nothing
		Set rsStoreData2	= Nothing
	
	End Function
	'************************************************************************************
	
	

	'************************************************************************************
	'*																					*
	'*																					*
	'*																					*
	'************************************************************************************
	Function CART_CalcWeight()
	
		'need to take into account any products that have free shipping 
		'	based on date and/or quantity required(of that particular product)
		Dim sSQLText, rsStoreData, rsStoreData2
		
		Const C_vTRUE		= 1
		Const C_vFALSE		= 2
		Const C_vNOTSET		= 3
		CART_CalcWeight			= 0
		Set rsStoreData		= CreateObject("ADODB.Recordset")
		Set rsStoreData2	= CreateObject("ADODB.Recordset")
		
		If ( sIDCart <> "" ) Then
			' get max length
			sSQLText = "SELECT CP.Quantity, P.Length, P.Height, CP.unitWeight, P.Width, P.FreeShipping, P.FreeShipStartDate, P.FreeShipEndDate, P.FreeShipQty, P.idProduct FROM CartProducts CP (NOLOCK), Products P (NOLOCK) WHERE CP.IDCart = " & sIDCart & " AND CP.idProduct = P.idProduct"
			Call DB_getFromDatabase(sSQLText, rsStoreData2, "")
			While ( NOT rsStoreData2.EOF )
				iFreeShipping		= rsStoreData2("FreeShipping")
				dFreeShipStartDate	= rsStoreData2("FreeShipStartDate")
				dFreeShipEndDate	= rsStoreData2("FreeShipEndDate")
				iFreeShipQty		= rsStoreData2("FreeShipQty")
				iQuantity			= rsStoreData2("Quantity")
				iProductID			= rsStoreData2("idProduct")
				bFreeShipQty		= C_vNOTSET
				bFreeDates			= C_vNOTSET
				bNoShippingFee		= C_vFALSE

				If ( iFreeShipping = -1 ) Then
					' free shipping is turned on for this product.
					' 	check to see if this is to be included with the length sum
					If ( ( iFreeShipQty <= iQuantity ) And ( iFreeShipQty > 0 ) ) Then
						' they get free shipping -- if the dates aren't set and/or if the current date falls between the start/end dates
						bFreeShipQty = C_vTRUE
					Else
						' no free shipping based on this -- still need to check the dates
						If ( iFreeShipQty > 0 ) Then
							bFreeShipQty = C_vFALSE
						Else
							bFreeShipQty = C_vNOTSET
						End If
					End If
					
					If ( ( IsDate(dFreeShipStartDate) ) AND ( IsDate(dFreeShipEndDate) ) ) Then
						If ( ( DateDiff("n", Now, dFreeShipStartDate) < 0 ) And ( DateDiff("n", Now, dFreeShipEndDate) > 0 ) ) Then
							bFreeDates = C_vTRUE
						Else
							bFreeDates = C_vFALSE
						End If
					Else
						bFreeDates = C_vNOTSET
					End If
				End If
				
				' at least one of these two have to be true - having both unset doesn't mean free shipping
				If ( ( bFreeShipQty = C_vTRUE And ( bFreeDates = C_vNOTSET Or bFreeDates = C_vTRUE ) ) ) Then
					bNoShippingFee = C_vTRUE
				End If
				
				If ( ( bFreeDates = C_vTRUE And ( bFreeShipQty = C_vNOTSET Or bFreeShipQty = C_vTRUE ) ) ) Then
					bNoShippingFee = C_vTRUE
				End If
				
				' only add the weight to the max's if the product doesn't get free shipping
				If ( bNoShippingFee <> C_vTRUE ) Then
					CART_CalcWeight	= CART_CalcWeight + CDbl( ( iQuantity * rsStoreData2("unitWeight") ) )
					
					' sum the weight of the options, if any
					sSQLText = "SELECT SUM(CP.quantity*O.weight) AS total FROM CartProducts CP, CartProductsOptions CPO, Options O WHERE CP.idCartRow = CPO.idCartRow AND CPO.idOption = O.idOption AND CP.IDCart=" & sIDCart & " AND CP.idProduct = " & iProductID
					Call DB_getFromDatabase(sSQLText, rsStoreData, "")
					if not rsStoreData.eof and not isNull(rsStoreData("total")) then
						CART_CalcWeight	= CART_CalcWeight + Cdbl(rsStoreData("total"))
					End If
					DB_closeRecordset(rsStoreData)
					
				End If
				
				rsStoreData2.MoveNext
			Wend
			DB_closeRecordset(rsStoreData2)
			
		End If
		
		Set rsStoreData = nothing
		Set rsStoreData2 = nothing
	
	End Function
	'************************************************************************************


	'************************************************************************************
	'*																					*
	'*																					*
	'*																					*
	'************************************************************************************
	Function CART_CalcQty()
	
		Dim rsStoreData
		
		Set rsStoreData = CreateObject("ADODB.Recordset")
		CART_CalcQty	= 0

		If ( sIDCart <> "" ) Then
			sSQLText = "SELECT SUM(quantity) AS qTotal FROM CartProducts WHERE IDCart=" & sIDCart 
			call DB_getFromDatabase(sSQLText, rsStoreData, "")        
			If ( NOT rsStoreData.EOF ) Then
				if NOT isNull(rsStoreData("qTotal")) then
					CART_CalcQty = Cdbl(rsStoreData("qTotal"))
				End If
			End If     
			DB_closeRecordset(rsStoreData)
		End If
		
		set rsStoreData = Nothing
	
	End Function
	'************************************************************************************



	'************************************************************************************
	'*																					*
	'*	This returns the total weight of all products in the current cart who have 		*
	'*		free shipping. This number can be used to figure the total weight to use	*
	'*		when calculating shipping price. Subtract this number from the overall		*
	'*		weight to find the weight to use when calculating the cost of shipping.		*
	'*																					*
	'*	This is seperate from the CART_CalcWeight() because there are times when we 	*
	'*		require the actual weight of the products within the cart.					*
	'*																					*
	'************************************************************************************
	function CART_CalcFreeShipWeight()
	
		Dim rsStoreData
		
		Set rsStoreData			= CreateObject("ADODB.Recordset")
		CART_CalcFreeShipWeight = 0
	
		If ( sIDCart <> "" ) Then
			' sum the total weight
			sSQLText = "SELECT CR.idCartRow, CR.UnitWeight, CR.Quantity, P.FreeShipStartDate, P.FreeShipEndDate, P.FreeShipQty FROM CartProducts CR, Products P WHERE (#" & CONVERSION_FormatDate(Now(), "L") & "# BETWEEN P.FreeShipStartDate AND P.FreeShipEndDate OR ((P.FreeShipStartDate='') AND (P.FreeShipEndDate=''))) AND CR.idCart = " & sIDCart & " AND CR.idProduct = P.idProduct AND P.FreeShipping = -1 AND (CR.Quantity >= P.FreeShipQty OR P.FreeShipQty = 0)"
			call DB_getFromDatabase(sSQLText, rsStoreData, "")
			While ( NOT rsStoreData.EOF )
				CART_CalcFreeShipWeight = CART_CalcFreeShipWeight + (CDbl(rsStoreData("UnitWeight")) * Cdbl(rsStoreData("Quantity")))
				' now get the weight added by any options associated w/ this (if there are any in the cart)
				sSQLText = "SELECT Sum(O.Weight) FROM Options O, CartProductsOptions CRO WHERE CRO.idCartRow = " & rsStoreData("idCartRow") & " AND CRO.idOption = O.idOption"
				call DB_getFromDatabase(sSQLText, rsStoreData2, "")
				If ( NOT rsStoreData2.EOF ) Then
					If ( NOT IsNull(rsStoreData2(0)) ) Then
						CART_CalcFreeShipWeight = CART_CalcFreeShipWeight + (CDbl(rsStoreData2(0)) * Cdbl(rsStoreData("Quantity")))
					End If
				End If
				DB_closeRecordset(rsStoreData2)
				rsStoreData.MoveNext
			Wend
			DB_closeRecordset(rsStoreData)
		End If
		
		set rsStoreData	= nothing
		
	End Function
	'************************************************************************************



	'************************************************************************************
	'*																					*
	'*																					*
	'*																					*
	'************************************************************************************
	function CART_CalcFreeShipQty()
	
		Dim rsStoreData
	
		Set rsStoreData			= CreateObject("ADODB.Recordset")
		CART_CalcFreeShipQty	= 0
	
		If ( sIDCart <> "" ) Then
			sSQLText = "SELECT SUM(quantity) FROM CartProducts, products WHERE IDCart=" & sIDCart & " AND CartProducts.idProduct=products.idProduct AND freeShipping=-1" 
			call DB_getFromDatabase(sSQLText, rsStoreData, "cartFunctions")        
			If ( NOT rsStoreData.EOF ) Then
				if NOT isNull(rsStoreData(0)) then
					CART_CalcFreeShipQty = Cdbl(rsStoreData(0))
				End If
			End If     
			DB_closeRecordset(rsStoreData)
		End If
		
		set rsStoreData = nothing
	
	End Function
	'************************************************************************************


	'************************************************************************************
	'*																					*
	'*																					*
	'*																					*
	'************************************************************************************
	function CART_CalcFreeShipTtl()       
	
		Dim rsStoreData2, sOptionsTotal, rsStoreData
		
		set rsStoreData		= CreateObject("ADODB.Recordset")
		set rsStoreData2	= CreateObject("ADODB.Recordset")
	
		If ( sIDCart <> "" ) Then
			' iterate through FS cart rows
			sSQLText = "SELECT idCartRow, idProduct, quantity, unitPrice, unitBtoBPrice FROM CartProducts, products WHERE IDCart=" & sIDCart & " AND CartProducts.idProduct=products.idProduct AND freeShipping=-1"   
			call DB_getFromDatabase(sSQLText, rsStoreData, "cartFunctions")  
			do while not rsStoreData.eof
				sUnitPrice		= Cdbl(rsStoreData("unitPrice"))
				sUnitBtoBPrice	= Cdbl(rsStoreData("unitBtoBPrice"))
				sQuantity		= rsStoreData("quantity")
				sIDCartRow		= rsStoreData("idCartRow")
				sIDProduct		= rsStoreData("idProduct")
				sOptionsTotal	= 0
		
				' get Optionals value for that row    
				sSQLText = "SELECT SUM(CartProductsOptions.priceToAdd) AS optionsTotal FROM options, CartProductsOptions WHERE options.idOption=CartProductsOptions.idOption AND CartProductsOptions.idCartRow="&sIDCartRow     
				call DB_getFromDatabase(sSQLText, rsStoreData2, "cartFunctions")  
				If ( NOT rsStoreData2.EOF ) Then
					if NOT isNull(rsStoreData2("optionsTotal")) then
						sOptionsTotal = Cdbl(rsStoreData2("optionsTotal"))
					End If
				End If        
				DB_closeRecordset(rsStoreData2)

				If ( ( ACCNT_InGroup(iLoginAccountUnq, C_GROUP_WHOLESALE) ) And ( sUnitBtoBPrice > 0 ) ) Then
					CART_CalcFreeShipTtl = CDbl(CART_CalcFreeShipTtl + sQuantity * (sUnitBtoBPrice + sOptionsTotal))
				Else
					CART_CalcFreeShipTtl = CDbl(CART_CalcFreeShipTtl + sQuantity * (sUnitPrice + sOptionsTotal))
				End If
				rsStoreData.movenext
			loop   
			DB_closeRecordset(rsStoreData)
		End If

		set rsStoreData	= nothing
		set rsStoreData2	= nothing
	
	End Function
	'************************************************************************************


	'************************************************************************************
	'*																					*
	'*																					*
	'*																					*
	'************************************************************************************
	Sub CART_CalcVolume(sMaxLength, sMaxHeight, sSumWidth)
	
		'need to take into account any products that have free shipping 
		'	based on date and/or quantity required(of that particular product)
		Dim sSQLText, rsStoreData, rsStoreData2, iOWInterWidth
		
		Const C_vTRUE		= 1
		Const C_vFALSE		= 2
		Const C_vNOTSET		= 3
		
		iOWInterWidth		= owCONFIG_ReturnConfigValue("iOWInterWidth")
		sSumWidth			= 0
		sMaxLength			= 0
		sMaxHeight			= 0
		Set rsStoreData		= CreateObject("ADODB.Recordset")
		Set rsStoreData2	= CreateObject("ADODB.Recordset")
		
		If ( sIDCart <> "" ) Then
			' get max length
			sSQLText = "SELECT CP.Quantity, P.Length, P.Height, CP.unitWeight, P.Width, P.FreeShipping, P.FreeShipStartDate, P.FreeShipEndDate, P.FreeShipQty, P.idProduct FROM CartProducts CP (NOLOCK), Products P (NOLOCK) WHERE CP.IDCart = " & sIDCart & " AND CP.idProduct = P.idProduct"
			Call DB_getFromDatabase(sSQLText, rsStoreData2, "")
			While ( NOT rsStoreData2.EOF )
				iFreeShipping		= rsStoreData2("FreeShipping")
				dFreeShipStartDate	= rsStoreData2("FreeShipStartDate")
				dFreeShipEndDate	= rsStoreData2("FreeShipEndDate")
				iFreeShipQty		= rsStoreData2("FreeShipQty")
				iQuantity			= rsStoreData2("Quantity")
				iLength				= rsStoreData2("Length")
				iHeight				= rsStoreData2("Height")
				iProductID			= rsStoreData2("idProduct")
				bFreeShipQty		= C_vNOTSET
				bFreeDates			= C_vNOTSET
				bNoShippingFee		= C_vFALSE

				If ( iFreeShipping = -1 ) Then
					' free shipping is turned on for this product.
					' 	check to see if this is to be included with the length sum
					If ( ( iFreeShipQty <= iQuantity ) And ( iFreeShipQty > 0 ) ) Then
						' they get free shipping -- if the dates aren't set and/or if the current date falls between the start/end dates
						bFreeShipQty = C_vTRUE
					Else
						' no free shipping based on this -- still need to check the dates
						If ( iFreeShipQty > 0 ) Then
							bFreeShipQty = C_vFALSE
						Else
							bFreeShipQty = C_vNOTSET
						End If
					End If
					
					If ( ( IsDate(dFreeShipStartDate) ) AND ( IsDate(dFreeShipEndDate) ) ) Then
						If ( ( DateDiff("n", Now, dFreeShipStartDate) < 0 ) And ( DateDiff("n", Now, dFreeShipEndDate) > 0 ) ) Then
							bFreeDates = C_vTRUE
						Else
							bFreeDates = C_vFALSE
						End If
					Else
						bFreeDates = C_vNOTSET
					End If
				End If
				
				' at least one of these two have to be true - having both unset doesn't mean free shipping
				If ( ( bFreeShipQty = C_vTRUE And ( bFreeDates = C_vNOTSET Or bFreeDates = C_vTRUE ) ) ) Then
					bNoShippingFee = C_vTRUE
				End If
				
				If ( ( bFreeDates = C_vTRUE And ( bFreeShipQty = C_vNOTSET Or bFreeShipQty = C_vTRUE ) ) ) Then
					bNoShippingFee = C_vTRUE
				End If
				
				' only add the length/height/width to the max's if the product doesn't get free shipping
				If ( bNoShippingFee <> C_vTRUE ) Then
					If ( sMaxLength < Cdbl(iLength) ) Then
						sMaxLength = Cdbl(iLength)
					End If
					If ( sMaxHeight < Cdbl(iHeight) ) Then
						sMaxHeight = Cdbl(iHeight)
					End If
					sSumWidth = sSumWidth + CDbl((iQuantity*rsStoreData2("width")) + (iQuantity*Cdbl(iOWInterWidth)))
				End If
				
				rsStoreData2.MoveNext
			Wend
			DB_closeRecordset(rsStoreData2)
			
		End If
		
		Set rsStoreData = nothing
		Set rsStoreData2 = nothing
	
	End Sub
	'************************************************************************************
	
	
	'************************************************************************************
	'*																					*
	'*																					*
	'*																					*
	'************************************************************************************
	Sub CART_PaymentMethodInfo(iPaymentID, bPaymentActive, sPaymentDescription, sPaymentPriceToAdd, sPaymentPercentageToAdd)
		
		Select Case iPaymentID
			Case C_PM_Offline
				sPaymentDescription		= LANG_DT( "CART_PM_CC", "Credit Cards" )
				bPaymentActive			= CONVERSION_Numeric(owCONFIG_ReturnConfigValue("sOWCreditCardsActive"), C_INTEGER)
				sPaymentPriceToAdd		= CONVERSION_Numeric(owCONFIG_ReturnConfigValue("sOWCreditCardsPriceToAdd"), C_DOUBLE)
				sPaymentPercentageToAdd	= CONVERSION_Numeric(owCONFIG_ReturnConfigValue("sOWCreditCardsPercentToAdd"), C_DOUBLE)
				sOWCreditCardsAccepted	= owCONFIG_ReturnConfigValue("sOWCreditCardsAccepted")		' must be declared global in whatever page this is used (just owOfflineCC.asp right now)
				
			Case C_PM_MAILIN
				sPaymentDescription		= LANG_DT( "CART_PM_MAILIN", "Mail-In" )
				bPaymentActive			= CONVERSION_Numeric(owCONFIG_ReturnConfigValue("sOWMailInActive"), C_INTEGER)
				sPaymentPriceToAdd		= CONVERSION_Numeric(owCONFIG_ReturnConfigValue("sOWMailInPriceToAdd"), C_DOUBLE)
				sPaymentPercentageToAdd	= CONVERSION_Numeric(owCONFIG_ReturnConfigValue("sOWMailInPercentToAdd"), C_DOUBLE)
				
			Case C_PM_FAXIN
				sPaymentDescription		= LANG_DT( "CART_PM_FAXIN", "Fax-In" )
				bPaymentActive			= CONVERSION_Numeric(owCONFIG_ReturnConfigValue("sOWFaxInActive"), C_INTEGER)
				sPaymentPriceToAdd		= CONVERSION_Numeric(owCONFIG_ReturnConfigValue("sOWFaxInPriceToAdd"), C_DOUBLE)
				sPaymentPercentageToAdd	= CONVERSION_Numeric(owCONFIG_ReturnConfigValue("sOWFaxInPercentToAdd"), C_DOUBLE)
			
			Case C_PM_PHONEIN
				sPaymentDescription		= LANG_DT( "CART_PM_PHONEIN", "Phone-In" )
				bPaymentActive			= CONVERSION_Numeric(owCONFIG_ReturnConfigValue("sOWPhoneInActive"), C_INTEGER)
				sPaymentPriceToAdd		= CONVERSION_Numeric(owCONFIG_ReturnConfigValue("sOWPhoneInPriceToAdd"), C_DOUBLE)
				sPaymentPercentageToAdd	= CONVERSION_Numeric(owCONFIG_ReturnConfigValue("sOWPhoneInPercentToAdd"), C_DOUBLE)
				
			Case C_PM_COD
				sPaymentDescription		= LANG_DT( "CART_PM_COD", "COD" )
				bPaymentActive			= CONVERSION_Numeric(owCONFIG_ReturnConfigValue("sOWCODActive"), C_INTEGER)
				sPaymentPriceToAdd		= CONVERSION_Numeric(owCONFIG_ReturnConfigValue("sOWCODPriceToAdd"), C_DOUBLE)
				sPaymentPercentageToAdd	= CONVERSION_Numeric(owCONFIG_ReturnConfigValue("sOWCODPercentToAdd"), C_DOUBLE)
				
			Case C_PM_PayPal
				sPaymentDescription		= LANG_DT( "CART_PM_PAYPAL", "PayPal" )
				bPaymentActive			= CONVERSION_Numeric(owCONFIG_ReturnConfigValue("sOWPayPalActive"), C_INTEGER)
				sPaymentPriceToAdd		= CONVERSION_Numeric(owCONFIG_ReturnConfigValue("sOWPayPalPriceToAdd"), C_DOUBLE)
				sPaymentPercentageToAdd	= CONVERSION_Numeric(owCONFIG_ReturnConfigValue("sOWPayPalPercentToAdd"), C_DOUBLE)
				
			Case Else
		End Select
		
		If ( bPaymentActive = "" ) Then
			' this is in case that payment method hasn't yet been added to the database. the owCONFIG_ReturnConfigValue will return a blank and we
			'	want to take that and "turn off" that payment method's code throughout the store
			bPaymentActive = False
		End If
		
	End Sub
	'************************************************************************************
%>