<%
	'************************************************************************************
	'*																					*
	'*																					*
	'*																					*
	'************************************************************************************
	Function encrypt(text, password)
	
		encrypt = RC4EnCryptASC(text, password)
		
	End Function
	'************************************************************************************



	'************************************************************************************
	'*																					*
	'*																					*
	'*																					*
	'************************************************************************************
	Function decrypt(text, password)
	
		decrypt=RC4DeCryptASC(text, password)
	
	End Function
	'************************************************************************************


   Dim sbox(255)
   Dim rc4Key(255)
   
	'************************************************************************************
	'*																					*
	'*	This script performs 'RC4' Stream Encryption (Based on what is widely			*
	'*		thought to be RSA's RC4 algorithm. 	It produces output streams that			*
	'*		are identical to the commercial products). This script is Copyright  		*
	'*		1999 by Mike Shaffer ALL RIGHTS RESERVED WORLDWIDE							*
	'*																					*
	'*	this routine called by EnDeCrypt function. Initializes the sbox and the 		*
	'*		key array																	*
	'*																					*
	'************************************************************************************
	Sub RC4Initialize(strPwd)

		dim tempSwap, a, b      
		
		' get length of the key
		intLength = len(strPwd)
		
		' iterate through all characters contained in key repeating number of characters is 255
		for a = 0 To 255
			rc4Key(a)	= asc(mid(strpwd, (a mod intLength)+1, 1))		' load ANSI for each char contained in the key
			sbox(a)		= a												' load numbers from 0 to 255
		next
		
		b = 0
		' iterate through arrays 
		for a = 0 To 255
			b = (b + sbox(a) + rc4Key(a)) Mod 256         
			tempSwap = sbox(a)
			sbox(a) = sbox(b)
			sbox(b) = tempSwap
		Next
	
	End Sub
	'************************************************************************************
   
   
   
	'************************************************************************************
	'*																					*
	'*																					*
	'*																					*
	'************************************************************************************
	function EnDeCrypt(plaintxt, psw)
	
		dim temp, a, i, j, k, cipherby, cipher      
		
		i = 0
		j = 0
		
		Call RC4Initialize(psw)
		
		for a = 1 To Len(plaintxt)
			i			= (i + 1) Mod 256
			j			= (j + sbox(i)) Mod 256
			temp 		= sbox(i)
			sbox(i)		= sbox(j)
			sbox(j)		= temp
			k 			= sbox((sbox(i) + sbox(j)) Mod 256)
			cipherby	= Asc(Mid(plaintxt, a, 1)) Xor k
			cipher		= cipher & Chr(cipherby)
		next
		
		enDeCrypt = cipher
	
	End Function
	'************************************************************************************
   

	'************************************************************************************
	'*																					*
	'*																					*
	'*																					*
	'************************************************************************************
	Function RC4EnCryptASC(plaintxt, psw)      
	
		dim temp, a, i, j, k, cipherby, cipher      
		
		i = 0
		j = 0
		
		Call RC4Initialize(psw)
		
		for a = 1 To Len(plaintxt)
			i 			= (i + 1) Mod 256
			j 			= (j + sbox(i)) Mod 256
			temp 		= sbox(i)
			sbox(i)		= sbox(j)
			sbox(j)		= temp
			k 			= sbox((sbox(i) + sbox(j)) Mod 256)
			cipherby 	= Asc(Mid(plaintxt, a, 1)) Xor k         
			cipher 		= cipher & "|"& cipherby         
		next            
		
		RC4EnCryptASC = cipher
	
	End Function
	'************************************************************************************
   
   
   
	'************************************************************************************
	'*																					*
	'*																					*
	'*																					*
	'************************************************************************************
	Function RC4DeCryptASC(plaintxt, psw)      

		dim temp, a, i, j, k, cipherby, cipher, arrayEncrypted
		
		i			= 0
		j			= 0
		plaintxt	= transformToCHR(plaintxt)
		
		Call RC4Initialize(psw)
		
		for a = 1 To Len(plaintxt)
			i 			= (i + 1) Mod 256
			j 			= (j + sbox(i)) Mod 256
			temp 		= sbox(i)
			sbox(i)		= sbox(j)
			sbox(j)		= temp
			k 			= sbox((sbox(i) + sbox(j)) Mod 256)
			cipherby 	= Asc(Mid(plaintxt, a, 1)) Xor k
			cipher 		= cipher & Chr(cipherby)         
		next
		
		RC4DeCryptASC = cipher                       
	
	End Function
	'************************************************************************************


	'************************************************************************************
	'*																					*
	'*																					*
	'*																					*
	'************************************************************************************
	function transformToCHR(plaintxt)
	      
	      Dim arrayEncrypted

	      arrayEncrypted	= split(plaintxt, "|")            

	      ' transform to CHR
	      for a = 1 to ubound(arrayEncrypted)         
	         transformToCHR = transformToCHR & CHR(arrayEncrypted(a))         
	      next            
	      
	End Function
	'************************************************************************************
%>