<%
	'************************************************************************************
	'*																					*
	'*	MODIFICATION TO THIS SCRIPT OR ANY FILES INCLUDED WITH 							*
	'*		ONEWORLDSTOREFRONT IS DONE AT YOUR OWN RISK!								*
	'*	Product  : OneWorldStoreFront													*

	'*	Copyright:	Copyright (C) 2004 OneWorldStoreFront.Com							*
	'*				Registration Number: 1024507										*
	'*				http://strategis.ic.gc.ca/											*
	'*																					*
	'************************************************************************************

	'************************************************************************************
	'*																					*
	'*	Width, length and height are all from 1 to 108.00								*
	'*	Weight maxes out at 150.0 and can go as low as .1								*
	'*																					*
	'************************************************************************************
	Function ReturnUPS(sOriginatingState, sOriginatingCountry, sOriginatingZip, sOriginatingCity, sDestState, sDestCountry, sDestZip, dShipWeight, dLength, dHeight, dWidth, bShippingFound, sErrorMsg)

		sOWUpsLicense		= owCONFIG_ReturnConfigValue("sOWUpsLicense")
		sOWUpsUser			= owCONFIG_ReturnConfigValue("sOWUpsUser")
		sOWUpsPassword		= owCONFIG_ReturnConfigValue("sOWUpsPassword")
		sOWUPSDestType		= owCONFIG_ReturnConfigValue("sOWUPSDestType")
		sOWUPSPackageType	= owCONFIG_ReturnConfigValue("sOWUPSPackageType")
		sOWUPSPickupType	= owCONFIG_ReturnConfigValue("sOWUPSPickupType")

		If ( sOWUPSDestType = "RES" ) Then
			sOWUPSDestType = "<ResidentialAddress>1</ResidentialAddress>"
		else
			sOWUPSDestType = "<ResidentialAddress>0</ResidentialAddress>"
		end if

		' make sure the weight and size measurements are both either metric or U.S. Customary units 
		If ( ( sOWShipWeightType = "LBS" ) And ( sOWShipDimensionType = "CM" ) ) Then
			sOWShipWeightType = "KGS"
			dShipWeight		= dShipWeight * 2.2
		ElseIf ( ( sOWShipWeightType = "KGS" ) And ( sOWShipDimensionType = "IN" ) ) Then
			sOWShipWeightType = "LBS"
			dShipWeight		= dShipWeight / 2.2
		End If
	 	If ( sOWCurrencyCode = "" ) Then
	 		' just in case someone decides to delete the currency code
	 		sTempCurrencyCode = "USD"
	 	Else
	 		sTempCurrencyCode = sOWCurrencyCode
	 	End If

		If ( dLength <= 0 ) Then
			dLength = 1
		End If
		If ( dWidth <= 0 ) Then
			dWidth = 1
		End If
		If ( dHeight <= 0 ) Then
			dHeight = 1
		End If

		Set sXMLData = New StrConCatArray	' Marcus Tucker's object - supra-fast string concatenation! yey!
		sXMLData.Add "<?xml version=""1.0""?>"
		sXMLData.Add "<AccessRequest xml:lang=""en-US"">"
		sXMLData.Add "<AccessLicenseNumber>" & sOWUpsLicense & "</AccessLicenseNumber>"
		sXMLData.Add "<UserId>" & sOWUpsUser & "</UserId>"
		sXMLData.Add "<Password>" & sOWUpsPassword & "</Password>"
		sXMLData.Add "</AccessRequest>"
		sXMLData.Add "<?xml version=""1.0""?>"
		sXMLData.Add "<RatingServiceSelectionRequest xml:lang=""en-US"">"
		sXMLData.Add "<Request>"
		sXMLData.Add "<TransactionReference>"
		sXMLData.Add "<CustomerContext>Rating and Service</CustomerContext>"
		sXMLData.Add "<XpciVersion>1.0001</XpciVersion>"
		sXMLData.Add "</TransactionReference>"
		sXMLData.Add "<RequestAction>rate</RequestAction>"
		sXMLData.Add "<RequestOption>shop</RequestOption>"
		sXMLData.Add "</Request>"
		sXMLData.Add "<PickupType>"
		sXMLData.Add "<Code>" & sOWUPSPickupType & "</Code>"
		sXMLData.Add "</PickupType>"
		sXMLData.Add "<Shipment>"
		sXMLData.Add "<Shipper>"
		sXMLData.Add "<Address>"
		sXMLData.Add "<City>" & sOriginatingCity & "</City>"
		sXMLData.Add "<StateProvinceCode>" & sOriginatingState & "</StateProvinceCode>"
		sXMLData.Add "<PostalCode>" & Replace(sOriginatingZip, " ", "") & "</PostalCode>"
		sXMLData.Add "<CountryCode>" & sOriginatingCountry & "</CountryCode>"
		sXMLData.Add "</Address>"
		sXMLData.Add "</Shipper>"
		sXMLData.Add "<ShipTo>"
		sXMLData.Add "<Address>"
		sXMLData.Add "<City>" & sDestCity & "</City>"
		sXMLData.Add "<StateProvinceCode>" & sDestState & "</StateProvinceCode>"
		sXMLData.Add "<PostalCode>" & sDestZip & "</PostalCode>"
		sXMLData.Add "<CountryCode>" & sDestCountry & "</CountryCode>"
		sXMLData.Add sOWUPSDestType
		sXMLData.Add "</Address>"
		sXMLData.Add "</ShipTo>"
		sXMLData.Add "<Package>"
		sXMLData.Add "<PackagingType>"
		sXMLData.Add "<Code>" & sOWUPSPackageType & "</Code>"
		sXMLData.Add "<Description>Package</Description>"
		sXMLData.Add "</PackagingType>"
		sXMLData.Add "<Description>Rate Shopping</Description>"
		sXMLData.Add "<Dimensions>"
		sXMLData.Add "<UnitOfMeasurement><Code>"
		sXMLData.Add sOWShipDimensionType
		sXMLData.Add "</Code></UnitOfMeasurement>"
		sXMLData.Add "<Length>" & dLength & "</Length>"
		sXMLData.Add "<Width>" & dWidth & "</Width>"
		sXMLData.Add "<Height>" & dHeight & "</Height>"
		sXMLData.Add "</Dimensions>"
		sXMLData.Add "<PackageWeight>"
		sXMLData.Add "<UnitOfMeasurement>"
		sXMLData.Add "<Code>"
		sXMLData.Add sOWShipWeightType
		sXMLData.Add "</Code>"
		sXMLData.Add "</UnitOfMeasurement>"
		sXMLData.Add "<Weight>" & dShipWeight & "</Weight>"
		sXMLData.Add "</PackageWeight>"
		sXMLData.Add "<OversizePackage>0</OversizePackage>"
	 	sXMLData.Add "<PackageServiceOptions>"
	 	sXMLData.Add "<InsuredValue>"
		sXMLData.Add "<CurrencyCode>" & sTempCurrencyCode & "</CurrencyCode>"
	 	sXMLData.Add "<MonetaryValue>100</MonetaryValue>"
	 	sXMLData.Add "</InsuredValue>"
	 	sXMLData.Add "</PackageServiceOptions>"
		sXMLData.Add "</Package>"
		sXMLData.Add "</Shipment>"
		sXMLData.Add "</RatingServiceSelectionRequest>"

		Set srvXmlHttp = server.createobject("Msxml2.serverXmlHttp")
		Set objXMLData = server.CreateObject("Msxml2.DOMDocument")
		srvXmlHttp.open "POST", "https://www.ups.com/ups.app/xml/Rate", false
		srvXmlHttp.send(sXMLData.Value)

		Set sXMLData = Nothing
		sResponse 			= srvXmlHttp.responseText

		objXMLData.async	= false 
		If ( objXMLData.loadXML(sResponse) ) Then
			set objXMLList = objXMLData.getElementsByTagName("ErrorDescription")
			If ( objXMLList.Length > 0 ) Then
				sErrorMsg = objXMLList.item(0).text		' gets it from the error
				set objXMLList2 = objXMLData.getElementsByTagName("ErrorLocationElementName")
				If ( objXMLList2.Length > 0 ) Then
					sErrorMsg = sErrorMsg & "<BR>" & objXMLList2.item(0).text
				End If
				set objXMLList2 = Nothing
			Else
				set objXMLList = objXMLData.getElementsByTagName("RatedShipment") 
				Set objstrTemp = New StrConCatArray
				For iX = 0 to (objXMLList.length - 1)
					bShippingFound = False
					For iY = 0 to ((objXMLList.item(iX).childNodes.length)-1)
						If ( objXMLList.item(iX).childNodes(iY).nodeName = "Service" ) Then
							objstrTemp.Add "|" & objXMLList.item(iX).childNodes(iY).text
							bShippingFound = True
						End if
						If ( objXMLList.item(iX).childNodes(iY).nodeName = "TotalCharges" ) Then
							For iZ=0 to ((objXMLList.item(iX).childNodes(iY).childNodes.length)-1)
								if objXMLList.item(iX).childNodes(iY).childNodes(iZ).nodeName="MonetaryValue" then
									objstrTemp.Add"|"&objXMLList.item(iX).childNodes(iY).childNodes(iZ).text
								end if
							next
						End if
						If ( ( objXMLList.item(iX).childNodes(iY).nodeName = "GuaranteedDaysToDelivery" ) And ( bShippingFound ) ) Then
							If ( objXMLList.item(iX).childNodes(iY).text = "1" ) Then
								objstrTemp.Add"|Next Day"
							Else
								If ( objXMLList.item(iX).childNodes(iY).text <> "" ) Then
									objstrTemp.Add"|" & objXMLList.item(iX).childNodes(iY).text & " Days"
								Else
									objstrTemp.Add"|-1"
								End If
							End If
						End If
						If ( ( objXMLList.item(iX).childNodes(iY).nodeName = "ScheduledDeliveryTime" ) And ( bShippingFound ) ) Then
							If ( objXMLList.item(iX).childNodes(iY).text <> "" ) Then
								objstrTemp.Add" by " & objXMLList.item(iX).childNodes(iY).text
							End If
						End If
					Next
					objstrTemp.Add VbCrlf
				Next
				ReturnUPS = objstrTemp.Value
			End If
			set objXMLList = Nothing
		Else
			sErrorMsg = LANG_DT( "ISHIPPING_UPSDISCONNECT", "Unable to communicate with UPS to retrieve real-time shipping quotes." )
		End If

		Set srvXmlHttp = Nothing
		Set objXMLData = Nothing

	End Function
	'************************************************************************************

	
	
	'************************************************************************************
	'*																					*
	'*	USPS Domestic shipping															*
	'*																					*
	'************************************************************************************
	Function ReturnUSPS(sOriginatingState, sOriginatingCountry, sOriginatingZip, sOriginatingCity, sDestState, sDestCountry, sDestZip, dShipWeight, dLength, dHeight, dWidth, bShippingFound, sErrorMsg)

		If ( bCUSTOM_ReturnUSPS ) Then
			Call CustomReturnUSPS(sOriginatingState, sOriginatingCountry, sOriginatingZip, sOriginatingCity, sDestState, sDestCountry, sDestZip, dShipWeight, dLength, dHeight, dWidth, bShippingFound, sErrorMsg)
		Else
		
			sOWUSPSUser		= owCONFIG_ReturnConfigValue("sOWUSPSUser")
			sOWUSPSPassword	= owCONFIG_ReturnConfigValue("sOWUSPSPassword")
			sOWUSPSServices	= owCONFIG_ReturnConfigValue("aOWUSPSServices")
			sOWUSPSPackage	= owCONFIG_ReturnConfigValue("sOWUSPSPackage")
			sOWUSPSMachine	= owCONFIG_ReturnConfigValue("sOWUSPSMachine")
			bShippingFound	= False
			iLBS			= 0
			iOZ				= 1

			' see if kgs, convert if so
			If ( sOWShipWeightType = "KGS" ) Then
				dShipWeight = dShipWeight / 2.2
			End If

			' if it's larger than a fraction of an ounce, get the lbs and oz's
			If ( dShipWeight > 0.0625 ) Then
				iLBS	= Int(dShipWeight)
				iOZ		= (dShipWeight - iLBS) / .0625
			End If
			
			If ( sOWUSPSMachine = 0 ) Then
				sOWUSPSMachine = "FALSE"
			Else
				sOWUSPSMachine = "TRUE"
			End If

			aOWUSPSServices = Split(sOWUSPSServices, ", ", -1)
		
			Set sXMLData = New StrConCatArray
			sXMLData.Add "http://production.shippingapis.com/ShippingAPI.dll?API=RateV2&XML="
			sXMLData.Add "<RateV2Request USERID=""" & sOWUSPSUser & """ PASSWORD=""" & sOWUSPSPassword & """>"
			for iX = 0 to UBound(aOWUSPSServices)
				sXMLData.Add "<Package ID="""
				sXMLData.Add iX
				sXMLData.Add """>"
				sXMLData.Add "<Service>"
				sXMLData.Add UCase(aOWUSPSServices(iX))
				sXMLData.Add "</Service>"
				sXMLData.Add "<ZipOrigination>"
				sXMLData.Add sOriginatingZip
				sXMLData.Add "</ZipOrigination>"
				sXMLData.Add "<ZipDestination>"
				sXMLData.Add sDestZip
				sXMLData.Add "</ZipDestination>"
				sXMLData.Add "<Pounds>"
				sXMLData.Add iLBS
				sXMLData.Add "</Pounds>"
				sXMLData.Add "<Ounces>"
				sXMLData.Add iOZ
				sXMLData.Add "</Ounces>"
				sXMLData.Add "<Container>Flat Rate Box</Container>"
				sXMLData.Add "<Size>"
				sXMLData.Add sOWUSPSPackage
				sXMLData.Add "</Size>"
				sXMLData.Add "<Machinable>"
				sXMLData.Add sOWUSPSMachine
				sXMLData.Add "</Machinable>"
				sXMLData.Add "</Package>"
			Next
			sXMLData.Add "</RateV2Request>"

			Set srvXmlHttp = server.createobject("Msxml2.serverXmlHttp")
			Set objXMLData = server.CreateObject("Msxml2.DOMDocument")
			srvXmlHttp.open "GET", sXMLData.Value, false
'response.write sXMLData.Value
			srvXmlHttp.send(sXMLData.Value)
			Set sXMLData	= Nothing
			sResponse 		= srvXmlHttp.responseText
'response.write sResponse & "<BR><BR>"
'response.end
			'<RateV2Response>
			'	<Package ID="0">
			'		<ZipOrigination>10022</ZipOrigination>
			'		<ZipDestination>20008</ZipDestination>
			'		<Pounds>10</Pounds>
			'		<Ounces>5</Ounces>
			'		<Container>Flat Rate Box</Container>
			'		<Size>REGULAR</Size>
			'		<Zone>3</Zone>
			'		<Postage>
			'			<MailService>Priority Mail Flat Rate Box (11.25" x 8.75" x 6")</MailService>
			'			<Rate>7.70</Rate>
			'		</Postage>
			'		<Postage>
			'			<MailService>Priority Mail Flat Rate Box (14" x 12" x 3.5")</MailService>
			'			<Rate>7.70</Rate>
			'		</Postage>
			'	</Package>
			'		.
			'		.
			'		.
			'</RateV2Response>
			objXMLData.async	= false
			If ( objXMLData.loadXML(sResponse) ) Then
				Set objXMLList = objXMLData.SelectNodes("RateV2Response/Package")
				If ( objXMLList.Length > 0 ) Then
					Set sReturnText = New StrConCatArray
					sReturnText.Add VbCrlf
					For Each sNode In objXMLList
						If ( NOT sNode.selectSingleNode("Postage") Is Nothing ) Then
							sReturnText.Add "|" & aOWUSPSServices(sNode.getAttribute("ID")) & "|"
							sReturnText.Add sNode.selectSingleNode("Postage/Rate").Text & "|"
							sReturnText.Add "-1" & VbCrlf
							bShippingFound = True
						End If
					Next
					ReturnUSPS = sReturnText.Value
				Else
					Set objXMLList = objXMLData.SelectNodes("Error")
					If ( objXMLList.Length > 0 ) Then
						For Each sNode In objXMLList
							sErrorMsg = sNode.selectSingleNode("Description").Text
						Next
					Else
						' unable to get anything
						sErrorMsg = LANG_DT( "ISHIPPING_USPSPOSTNODATA", "Unable to retrieve USPS real-time shipping quotes data." )
					End If

				End If

				set objXMLList = Nothing
			Else
				sErrorMsg = LANG_DT( "ISHIPPING_USPSPOSTDISCONNECT", "Unable to communicate with USPS to retrieve real-time shipping quotes." )
			End If

			Set srvXmlHttp = Nothing
			Set objXMLData = Nothing
		
		End If
		
	End Function
	'************************************************************************************
	
	
	'************************************************************************************
	'*																					*
	'*	USPS International shipping															*
	'*																					*
	'************************************************************************************
	Function ReturnUSPSi(sOriginatingState, sOriginatingCountry, sOriginatingZip, sOriginatingCity, sDestState, sDestCountry, sDestZip, dShipWeight, dLength, dHeight, dWidth, bShippingFound, sErrorMsg)
		
		If ( bCUSTOM_ReturnUSPS ) Then
			Call CustomReturnUSPSi(sOriginatingState, sOriginatingCountry, sOriginatingZip, sOriginatingCity, sDestState, sDestCountry, sDestZip, dShipWeight, dLength, dHeight, dWidth, bShippingFound, sErrorMsg)
		Else
		
			sOWUSPSUser		= owCONFIG_ReturnConfigValue("sOWUSPSUser")
			sOWUSPSPassword	= owCONFIG_ReturnConfigValue("sOWUSPSPassword")
			sOWUSPSPackage	= owCONFIG_ReturnConfigValue("sOWUSPSPackage")
			sOWUSPSServices	= owCONFIG_ReturnConfigValue("aOWUSPSServices")
			bShippingFound	= False
			iLBS			= 0
			iOZ				= 1

			' see if kgs, convert if so
			If ( sOWShipWeightType = "KGS" ) Then
				dShipWeight = dShipWeight / 2.2
			End If

			' if it's larger than a fraction of an ounce, get the lbs and oz's
			If ( dShipWeight > 0.0625 ) Then
				iLBS	= Int(dShipWeight)
				iOZ		= (dShipWeight - iLBS) / .0625
			End If
			
			aOWUSPSServices = Split(sOWUSPSServices, ", ", -1)
			
			' get the country name
			sSQLText = "SELECT CountryName FROM CountryCodes WHERE CountryCode = '" & sDestCountry & "'"
			Call DB_getFromDatabase (sSQLText, rsStoreData, "")
			If ( NOT rsStoreData.EOF ) Then
				sDestCountry = rsStoreData("CountryName")
			End If
			Call DB_closeRecordset(rsStoreData)
		
			Set sXMLData = New StrConCatArray
			sXMLData.Add "http://production.shippingapis.com/ShippingAPI.dll?API=IntlRate&XML="
			sXMLData.Add "<IntlRateRequest USERID=""" & sOWUSPSUser & """ PASSWORD=""" & sOWUSPSPassword & """>"
			'for iX = 0 to UBound(aOWUSPSServices)
				sXMLData.Add "<Package ID=""0"
				'sXMLData.Add iX
				sXMLData.Add """>"
				sXMLData.Add "<Pounds>"
				sXMLData.Add iLBS
				sXMLData.Add "</Pounds>"
				sXMLData.Add "<Ounces>"
				sXMLData.Add iOZ
				sXMLData.Add "</Ounces>"
				sXMLData.Add "<MailType>Package</MailType>"
				sXMLData.Add "<Country>"
				sXMLData.Add sDestCountry
				sXMLData.Add "</Country>"
				sXMLData.Add "</Package>"
			'Next
			sXMLData.Add "</IntlRateRequest>"

			Set srvXmlHttp = server.createobject("Msxml2.serverXmlHttp")
			Set objXMLData = server.CreateObject("Msxml2.DOMDocument")
			srvXmlHttp.open "GET", sXMLData.Value, false

			srvXmlHttp.send(sXMLData.Value)
			Set sXMLData	= Nothing
			sResponse 		= srvXmlHttp.responseText

			'<IntlRateResponse>
			'<Package ID="0">
			'	<Prohibitions>Currency of the Albanian State Bank (Banknotes in lek). Extravagant clothes and other articles contrary to Albanians' taste. Items sent by political emigres. </Prohibitions>
			'	<Restrictions>Hunting arms require an import permit. Medicines for personal use are admitted provided the addressee has a medical certificate.</Restrictions>
			'	<Observations>1. Letter packages may not contain dutiable articles. 2. Parcel post service extends only to: Berat Konispol Milot Bilisht Korce Peqin</Observations>
			'	<CustomsForms>Postal Union Mail (LC/AO): PS Form 2976 or 2976-A (see 123.61) Parcel Post: PS Form 2976-A inside 2976-E (envelope)</CustomsForms>
			'	<ExpressMail>Country Code AL Reciprocal Service Name EMS Required Customs Form/Endorsement 1. For correspondence and business papers: PS Form 2976, Customs - CN 22 (Old C 1) and Sender's Declaration (green label). Endorse item clearly next to mailing label as BUSINESS PAPERS.</ExpressMail>
			'	<AreasServed>Tirana.</AreasServed>
			'	<Service ID="0">
			'		<Pounds>2</Pounds>
			'		<Ounces>0</Ounces>
			'		<MailType>Package</MailType>
			'		<Country>ALBANIA</Country>
			'		<Postage>87</Postage>
			'		<SvcCommitments>See Service Guide</SvcCommitments>
			'		<SvcDescription>Global Express Guaranteed (GXG) Document Service</SvcDescription>
			'		<MaxDimensions>Max. length 46", depth 35", height 46" and max. girth 108"</MaxDimensions>
			'		<MaxWeight>22</MaxWeight>
			'	</Service>
			'	<Service ID="1">
			'		<Pounds>2</Pounds>
			'		<Ounces>0</Ounces>
			'		<MailType>Package</MailType>
			'		<Country>ALBANIA</Country>
			'		<Postage>96</Postage>
			'		<SvcCommitments>See Service Guide</SvcCommitments>
			'		<SvcDescription>Global Express Guaranteed (GXG) Non-Document Service</SvcDescription>
			'		<MaxDimensions>Max. length 46", depth 35", height 46" and max. girth 108"</MaxDimensions>
			'		<MaxWeight>22</MaxWeight>
			'	</Service>
			'</Package>
			'</IntlRateResponse>
			objXMLData.async	= false
			If ( objXMLData.loadXML(sResponse) ) Then
				set objXMLList = objXMLData.getElementsByTagName("Description")
				If ( objXMLList.Length > 0 ) Then
				
					' get the error message
					
					'<IntlRateResponse>
					'	<Package ID="0">
					'		<Error>
					'			<Number>-2147218799</Number>
					'			<Source>SOLServerTest;SOLServerTest.CallIntlRateDll</Source>
					'			<Description>Invalid Country.</Description>
					'			<HelpFile></HelpFile>
					'			<HelpContext></HelpContext>
					'		</Error>
					'	</Package>
					'</IntlRateResponse>
					
					'<Error>
					'	<Number>80040b1a</Number>
					'	<Description>Authorization failure.  Perhaps username and/or password is incorrect.</Description>
					'	<Source>UspsCom::DoAuth</Source>
					'</Error>
					sErrorMsg = objXMLList.item(0).text		' gets it from the error
				Else
					set objXMLList = objXMLData.getElementsByTagName("Service")
					If ( IsObject(objXMLList) ) Then
						Set sReturnText = New StrConCatArray
						sReturnText.Add VbCrlf	'
						Set objHdl = objXMLList.item(0)
						sReturnText.Add "|Package|"
						sReturnText.Add objHdl.childNodes(4).text & "|"				' rate
						sReturnText.Add "-1" & VbCrlf								' delivery date is not returned
						bShippingFound = True
						ReturnUSPSi = sReturnText.Value
					Else
						' unable to get anything
						sErrorMsg = LANG_DT( "ISHIPPING_USPSIPOSTNODATA", "Unable to retrieve USPS International real-time shipping quotes data." )
					End If
				End If
				set objXMLList = Nothing
			Else
				sErrorMsg = LANG_DT( "ISHIPPING_USPSIPOSTDISCONNECT", "Unable to communicate with USPS to retrieve International real-time shipping quotes." )
			End If
	
			Set srvXmlHttp = Nothing
			Set objXMLData = Nothing
		
		End If
		
	End Function
	'************************************************************************************
	
	
	'************************************************************************************
	'*																					*
	'*																					*
	'*																					*
	'************************************************************************************
	Function ReturnCanadianPost(sOriginatingState, sOriginatingCountry, sOriginatingZip, sOriginatingCity, sDestState, sDestCountry, sDestZip, dShipWeight, dLength, dHeight, dWidth, bShippingFound, sErrorMsg)
	
		sOWCanadaPostCPC = owCONFIG_ReturnConfigValue("sOWCanadaPostCPC")
		bShippingFound = False

		' Canadian Post expects KGS as weight. Check it.
		If ( UCase(Trim(owCONFIG_ReturnConfigValue("sOWUPSWeightType"))) = "LBS" ) Then
			dWidth = Round(dWidth / 2.2, 2)
		End If

		Set sXMLData = New StrConCatArray	' Marcus Tucker's object - supra-fast string concatenation! yey!
		sXMLData.Add "<?xml version=""1.0""?>"
		sXMLData.Add "<eparcel>"
		sXMLData.Add "<language> en </language>"
		sXMLData.Add "<ratesAndServicesRequest>"
		sXMLData.Add "  <merchantCPCID> " & sOWCanadaPostCPC & " </merchantCPCID>"
		sXMLData.Add "  <lineItems>"
		sXMLData.Add "    <item>"
		sXMLData.Add "      <quantity> 1 </quantity>"
		sXMLData.Add "      <weight> " & dShipWeight & " </weight>"
		sXMLData.Add "      <length> " & dLength & " </length>"
		sXMLData.Add "      <width> " & dHeight & " </width>"
		sXMLData.Add "      <height> " & dWidth & " </height>"
		sXMLData.Add "      <description> N/A</description>"
		sXMLData.Add "    </item>"
		sXMLData.Add "  </lineItems>"
		sXMLData.Add "  <city>  </city>"
		sXMLData.Add "  <provOrState> " & sDestState & " </provOrState>"
		sXMLData.Add "  <country>  " & sDestCountry & " </country>"
		sXMLData.Add "  <postalCode> " & sDestZip & " </postalCode>"
		sXMLData.Add "</ratesAndServicesRequest>"
		sXMLData.Add "</eparcel>"

		Set srvXmlHttp = server.createobject("Msxml2.serverXmlHttp")
		Set objXMLData = server.CreateObject("Msxml2.DOMDocument")
		
		On Error Resume Next	' this is because the Canada Post server dies a LOT
		srvXmlHttp.open "POST", "http://206.191.4.228:30000", false		' test is at: http://206.191.4.228:30000 -- live is at: http://216.191.36.73:30000
		srvXmlHttp.send(sXMLData.Value)
		Set sXMLData = Nothing
		sResponse = srvXmlHttp.responseText

		'<eparcel>
		'	<ratesAndServicesResponse>
		'		<product id="1040" sequence="1">
		'			<name>Priority Courier</name>
		'			<rate>30.22</rate>
		'			<shippingDate>2004-12-22</shippingDate>
		'			<deliveryDate>2004-12-23</deliveryDate>
		'			<deliveryDayOfWeek>5</deliveryDayOfWeek>
		'			<nextDayAM>true</nextDayAM>
		'			<packingID>P_0</packingID>
		'		</product>
		'		.
		'		.
		'		.
		'	</ratesAndServicesResponse>
		'</eparcel>
		objXMLData.async	= false
		If ( objXMLData.loadXML(sResponse) ) Then
			set objXMLList = objXMLData.getElementsByTagName("error")
			If ( objXMLList.Length > 0 ) Then
				' get the error message
				'<eparcel>
				'	<error>
				'		<statusCode>-2001</statusCode>
				'		<statusMessage>Merchant CPC Id not found on server. </statusMessage>
				'		<requestID>193302</requestID>
				'	</error>
				'</eparcel>
				sErrorMsg = objXMLList.item(0).childNodes(1).text		' gets it from the <statusMessage> element
			Else
				set objXMLList = objXMLData.getElementsByTagName("product")
				If ( IsObject(objXMLList) ) Then
					Set sReturnText = New StrConCatArray
					sReturnText.Add VbCrlf	'
					For iX = 0 To (objXMLList.length - 1)
						Set objHdl = objXMLList.item(iX)
						sReturnText.Add "|" & objHdl.getAttribute("id") & "|"			' Canadian Post service id number
						sReturnText.Add objHdl.childNodes(1).text & "|"					' rate
						sReturnText.Add objHdl.childNodes(3).text & VbCrlf				' delivery date
					Next
					bShippingFound = True
					ReturnCanadianPost = sReturnText.Value
				Else
					' unable to get anything
					sErrorMsg = LANG_DT( "ISHIPPING_CANADAPOSTNODATA", "Unable to retrieve Canadian Post real-time shipping quotes data." )
				End If
			End If
			set objXMLList = Nothing
		Else
			sErrorMsg = LANG_DT( "ISHIPPING_CANADAPOSTDISCONNECT", "Unable to communicate with Canadian Post to retrieve real-time shipping quotes." )
		End If

		Set srvXmlHttp = Nothing
		Set objXMLData = Nothing
		On Error Goto 0
	
	End Function
	'************************************************************************************
	
	
	'************************************************************************************
	'*																					*
	'*																					*
	'*																					*
	'************************************************************************************
	Function ReturnFedEX()
	End Function
	'************************************************************************************
	
	
	
	'************************************************************************************
	'*																					*
	'*	Displays the UPS shipping estimate HTML table									*
	'*																					*
	'************************************************************************************
	Function SHIPPING_DispEstimate(sParseText, bDataReturned, bCheckout, pSubTotal)
	
		If ( sOWCurrencyCode <> "" ) Then
			sTempCurrencyCode = "(" & sOWCurrencyCode & ")"
		Else
			sTempCurrencyCode = "(USD)"
		End If
		
		Set objstrTemp = New StrConCatArray
	
		sSQLText = "SELECT * FROM UPSShippingMethods"
		Call DB_getFromDatabase(sSQLText, rsStoreData, "")
		If ( bCheckout = "T" ) Then
			' if bCheckout is "T" then we are displaying the form to allow customers to actually choose their shipping method - otherwise we are
			'	just displaying an estimate
			objstrTemp.Add "<table width=100" & "%" & " cellpadding=0 cellspacing=0 border=0><TR><TD style='border-bottom: 1px solid #EEEEEE;' colspan=2><b>" & LANG_DT( "ISHIPPING_DESC", "Shipment Description" ) & "</b></TD><TD width=150 style='border-bottom: 1px solid #EEEEEE;' align=center><b>" & LANG_DT( "ISHIPPING_COST", "Shipment Cost" ) & "</b>&nbsp;" & sTempCurrencyCode & "</TD><td width=50 style='border-bottom: 1px solid #EEEEEE;' align=center><b>" & LANG_DT( "ISHIPPING_SELECT", "Select?" ) & "</td></TR>"
		Else
			objstrTemp.Add "<table width=100" & "%" & " cellpadding=0 cellspacing=0 border=0><TR><TD style='border-bottom: 1px solid #EEEEEE;' colspan=2><b>" & LANG_DT( "ISHIPPING_DESC", "Shipment Description" ) & "</b></TD><TD width=150 style='border-bottom: 1px solid #EEEEEE;' align=center><b>" & LANG_DT( "ISHIPPING_COST", "Shipment Cost" ) & "</b>&nbsp;" & sTempCurrencyCode & "</TD></TR>"
		End If
		do until rsStoreData.eof 
			sHandlingFee			= rsStoreData("HandlingFee")
			sHandlingVisibility		= Trim(UCase(rsStoreData("HandlingVisibility")))
			sUPSInternalIDNum		= rsStoreData("UPSInternalIDNum")
			sUPSName				= rsStoreData("Name")
			sFreeShipping			= Trim(UCase(rsStoreData("FreeShipping")))
			sFreeShippingMinPrice	= CDbl(Trim(rsStoreData("FreeShippingMinPrice")))
	
			shipArray = split(sParseText, VbCrlf)
			for iX = 0 to (Ubound(shipArray))
				shipDetailsArray	= split(shipArray(iX),"|")
				sFreeShippingText	= ""
				tempRate			= ""
				if ubound(shipDetailsArray) > 0 then
					if shipDetailsArray(1) = sUPSInternalIDNum then
						If sHandlingVisibility = "Y" then
							tempRate = shipDetailsArray(2)
						Else
							' if handling is visible then DO NOT add it here to the shipping because they will see
							'	it in the order verify page. If you add it here, it'll get added again in the order verify page
							tempRate = (cDbl(shipDetailsArray(2)) + cDbl(sHandlingFee))
						End If

						' check method -- see if this order and method requirements match up for free shipping
						If ( sFreeShipping = "Y" ) Then
							sFreeShippingText = "<b>" & Replace(LANG_DT( "ISHIPPING_FREEMSG", " &#151; Ship using this method FREE on all orders over 1:" ), "1:", CONVERSION_Currency(sFreeShippingMinPrice)) & "<b>"
							If ( CDbl(pSubTotal) > CDbl(sFreeShippingMinPrice) ) Then	' free shipping is enabled for this method and they have reached the price limit required
								tempRate = 0
							End If
						End If
						
						If ( sFreeShippingText <> "" ) Then		' this is just to make it span 2 columns - otherwise it gets smashed in smaller screens
							objstrTemp.Add "<tr><td style='border-bottom: 1px solid #EEEEEE;' colspan=2>" & sUPSName & sFreeShippingText & "</td>"
						Else
							objstrTemp.Add "<tr><td style='border-bottom: 1px solid #EEEEEE;'>" & sUPSName & sFreeShippingText & "</td>"
							objstrTemp.Add "<td style='border-bottom: 1px solid #EEEEEE;'>&nbsp;"
							If ( shipDetailsArray(3) <> "-1" ) Then
								objstrTemp.Add LANG_DT( "ISHIPPING_ESTDEL", "Estimated delivery by" ) & ": " & shipDetailsArray(3)
							End If
							objstrTemp.Add "</td>"
						End If

						objstrTemp.Add "</td><td align=center style='border-bottom: 1px solid #EEEEEE;'>" & CONVERSION_Currency(tempRate) & "</td>"
						
						If ( bCheckout = "T" ) Then
							objstrTemp.Add "<td width=50 style='border-bottom: 1px solid #EEEEEE;' align=center>"
							
							If ( NOT bDataReturned ) Then 
								objstrTemp.Add "<input type='radio' name='sShipMethod' value='" & tempRate & "|UPS" & sUPSInternalIDNum & "' checked></td>"
							Else
								objstrTemp.Add "<input type='radio' name='sShipMethod' value='" & tempRate & "|UPS" & sUPSInternalIDNum & "' ></td>"
							End If
							Call DB_updateDatabase("INSERT INTO CartShipSecurity (idCart, ShipMethod, ShipCost) VALUES (" & sIDCart & ", 'UPS" & SQLEncode(sUPSInternalIDNum) & "', " & tempRate & ")")
						End If
						
						objstrTemp.Add "</tr>"
						bDataReturned = True
					end if
				end if
			next
			rsStoreData.movenext
		loop
		objstrTemp.Add "</table>"
		SHIPPING_DispEstimate = objstrTemp.Value
		Set objstrTemp = Nothing
		Call DB_closeRecordset(rsStoreData)
		
	End Function
	'************************************************************************************
%>